﻿// Weischbiers Base
// Created on 17/10/2012 at 18:12h
// PotionUser.cs created by Weischbier

using System;
using System.Diagnostics;
using System.Linq;
using Styx.Common;
using Styx.Plugins;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Action = System.Action;

namespace Weischbiers_Base.Plugins.Birthday
{
// ReSharper disable UnusedMember.Global
    public class Birthday : HBPlugin
// ReSharper restore UnusedMember.Global
    {
        #region Overrides of HBPlugin

        private bool _init;

        /// <summary>
        /// The text of the button if the plugin wants it. [Default: "Settings"]
        /// </summary>
        public override string ButtonText
        {
            get { return "Nothing here!"; }
        }

        /// <summary>
        /// Does this plugin want a button? If set to true, the button in the plugin manager will be enabled. [Default: false]
        /// </summary>
        public override bool WantButton
        {
            get { return false; }
        }

        /// <summary>
        /// The name of this plugin.
        /// </summary>
        public override string Name
        {
            get { return "WoW Birthday"; }
        }

        /// <summary>
        /// The author of this plugin.
        /// </summary>
        public override string Author
        {
            get { return "Weischbier"; }
        }

        /// <summary>
        /// The version of the plugin.
        /// </summary>
        public override Version Version
        {
            get { return new Version(1, 0, 0); }
        }

        /// <summary>
        /// Initializes this plugin after it has been properly loaded.
        /// </summary>
        public override void Initialize()
        {
            //Prevents double initialization
            if (_init) return;
            base.Initialize();
            Logging.Write(string.Format("Birthday ready to use . . ."));
            _init = true;
        }

        /// <summary>
        /// Called everytime the engine pulses.
        /// </summary>
        public override void Pulse()
        {
            UseItem(45067);
        }

        /// <summary>
        ///  Creates a behavior to use an item, in your bags or paperdoll.
        /// </summary>
        /// <param name="id"> The entry of the item to be used. </param>
        /// <returns>success or failure</returns>
        private static void UseItem(uint id)
        {
            var item = ObjectManager.GetObjectsOfType<WoWItem>().FirstOrDefault(it => it.Entry == id);
            if(item != null && CanUseItem(item))
                UseItem(item);
        }

        /// <summary>
        /// Checks the item cooldown is 0 and its usable
        /// </summary>
        /// <param name="item">the item to query</param>
        /// <returns>true of false</returns>
        private static bool CanUseItem(WoWItem item)
        {
            return item != null && item.Usable && item.Cooldown <= 0;
        }

        /// <summary>
        /// Uses the item specified (simulated click)
        /// </summary>
        /// <param name="item">The item to use</param>
        private static void UseItem(WoWItem item)
        {
            if (item != null)
            {
                item.Use();
            }
        }

        private static readonly Stopwatch Timer = new Stopwatch();
        private static readonly Random Randomize = new Random();
        private static readonly int Initrndm = Randomize.Next(7, 16);

        #endregion
    }
}